package net.robowiki.knn.implementations;

import ags.utils.dataStructures.trees.thirdGenKD.KdTree;
import ags.utils.dataStructures.trees.thirdGenKD.NearestNeighborIterator;
import net.robowiki.knn.util.KNNPoint;

import java.util.ArrayList;

public class Rednaxela3rdGenTreeKNNSearch extends KNNImplementation {
    private KdTree<String> tree;

    public Rednaxela3rdGenTreeKNNSearch(int dimension) {
        super(dimension);
        tree = new KdTree<String>(dimension);
    }

    @Override
    public void addPoint(double[] location, String value) {
        tree.addPoint(location, value);
    }

    @Override
    public KNNPoint[] getNearestNeighbors(double[] location, int size) {
        NearestNeighborIterator<String> iter = tree.getNearestNeighborIterator(location, size);
        ArrayList<KNNPoint> list = new ArrayList<KNNPoint>(size);
        while (list.size() < size) {
            String str = iter.next();
            double dist = iter.distance();
            list.add(new KNNPoint(str, dist));
        }
        return list.toArray(new KNNPoint[list.size()]);
    }

    @Override
    public String getName() {
        return "Rednaxela's kd-tree (3rd gen)";
    }
}
